diff -urp user_import_orig/supported/user.inc user_import/supported/user.inc
--- user_import_orig/supported/user.inc	2008-05-15 15:16:32.000000000 +0200
+++ user_import/supported/user.inc	2008-06-18 15:54:12.000000000 +0200
@@ -1,13 +1,23 @@
 <?php
+// $Id: user.inc,v 1.17.2.5 2008/05/15 13:16:31 MegaGrunt Exp $
+
+/**
+ * @file
+ * Include user module properties.
+ */
 
 /**
  * Implementation of hook_user_import_form_field_match().
  */
- function user_user_import_form_field_match() {
+function user_user_import_form_field_match() {
 
   $options = array();
-  $options['user']['email'] = t('Email Address*');
-  $options['user']['password'] = t('Password'); 
+
+  $options['user']['email'] = t('Email Address *');
+  $options['user']['password'] = t('Password');
+  $options['user']['role'] = t('Role');
+  $options['user']['language'] = t('Language');
+  $options['user']['delete'] = t('Delete');
 
   return $options;
 }
@@ -33,7 +43,7 @@ function user_user_import_data($settings
   if ($module != 'user') return;
 
   if ($field_id == 'email') {
-    $value = trim($data[$column_id]);  
+    $value = trim($data[$column_id]);
     _user_import_validate_email($value, $settings['options']['update_users']);
   }
 
@@ -41,6 +51,18 @@ function user_user_import_data($settings
     $value = trim($data[$column_id]);
   }
 
+  if ($field_id == 'role') {
+    $value = drupal_strtolower(trim($data[$column_id]));
+  }
+
+  if ($field_id == 'language') {
+    $value = drupal_strtolower(trim($data[$column_id]));
+  }
+
+  if ($field_id == 'delete') {
+    $value = drupal_strtolower(trim($data[$column_id]));
+  }
+
   return $value;
 }
 
@@ -49,48 +71,66 @@ function user_user_import_data($settings
  */
 function user_user_import_pre_save($settings, $account, $password, $fields, $errors) {
 
-	  $account_add['mail'] = $fields['user']['email'][0];
+  $account_add['mail'] = $fields['user']['email'][0];
 
-	if (empty($settings['options']['update_users'])) {
+  // get roles from csv
+  $role = $fields['user']['role'][0];
+  //check if role exists:
+
+  $rid = db_result(db_query("SELECT rid FROM {role} WHERE name = '%s'", $role));
+  if ($rid) {
+    $account_add['roles'][$rid] = $rid;
+  }
+  else {
+    // it doesn't exist, create it
+    db_query("INSERT INTO {role} (name) VALUES ('%s')", $role);
+    $rid = db_last_insert_id('role', 'rid');
+    $account_add['roles'][$rid] = $rid;
+  }
+    
+  if (empty($settings['options']['update_users'])) {
+
+    $account_add['timezone'] = '-18000';
+    $account_add['status'] = 1;
+    $account_add['init'] = $fields['user']['email'][0];
+    $account_add['pass'] = (empty($fields['user']['password'][0])) ? user_password() : $fields['user']['password'][0];
+    $account_add['language'] = $fields['user']['language'][0];
+
+    // get enabled roles
+    if (is_array($settings['roles'])) {
+      while (list ($rid, $role_set) = each ($settings['roles'])) {
+        if (!empty($role_set)) $account_add['roles'][$rid] = $rid;
+      }
+    }
+
+    if (!empty($settings['options']['activate'])) {
+      $account_add['access'] = time();
+      $account_add['login'] = time();
+    }
+
+    if ($settings['contact'] == 1) $account_add['contact'] = 1;
+  }
 
-	  $account_add['timezone'] = '-18000';
-	  $account_add['status'] = 1;
-	  $account_add['init'] = $fields['user']['email'][0];
-	  $account_add['pass'] = (empty($fields['user']['password'][0])) ? user_password() : $fields['user']['password'][0];
-
-	  // get enabled roles
-	  while (list ($rid, $role_set) = each ($settings['roles'])) {
-	      if (!empty($role_set)) $account_add['roles'][$rid] = $rid;
-	  }
-  
-	  if (!empty($settings['options']['activate'])) {
-	    $account_add['access'] = time();
-	    $account_add['login'] = time();
-	  }
-  
-	  if ($settings['contact'] == 1) $account_add['contact'] = 1; 
-	} 
-  
   return $account_add;
 }
 
 
-function user_user_import_edit_roles_fields(&$form, $import, $collapsed) { 
-        
+function user_user_import_edit_roles_fields(&$form, $import, $collapsed) {
+
   $roles_data = user_roles();
   // remove 'anonymous user' option
   while (list ($rid, $role_name) = each ($roles_data)) {
       if ($role_name != 'anonymous user' && $role_name != 'authenticated user') $roles[$rid] = $role_name;
   }
-  
+
   // roles selected
   if ( !empty($import['roles']) ) {
       foreach ($import['roles'] as $rid) {
           if ($rid != 0) $roles_selected[] = $rid;
       }
   }
-  
-  if ( empty($roles_selected) ) $roles_selected[] = 2; 
+
+  if ( empty($roles_selected) ) $roles_selected[] = 2;
 
   $form['role_selection'] = array(
       '#type' => 'fieldset',
@@ -100,72 +140,69 @@ function user_user_import_edit_roles_fie
       '#collapsible' => TRUE,
       '#collapsed' => $collapsed,
   );
-  
+
   $form['role_selection']['roles'] = array(
       '#type' => 'checkboxes',
       '#options' => $roles,
       '#default_value' => $roles_selected,
   );
-  
+
   return;
 }
 
-function user_user_import_edit_email_fields(&$form, $import, $collapsed) { 
+function user_user_import_edit_email_fields(&$form, $import, $collapsed) {
 
-    $form['email_message'] = array(
-        '#type' => 'fieldset',
-        '#title' => t('Email Message'),
-        '#description' => t('Welcome message to be sent to imported users. Leave blank to use the default !message.<br /><strong>Warning</strong>: if you copy and paste directly from Word some characters may get garbled.', array('!message' => l('message', 'admin/user/settings'))),
-        '#collapsible' => TRUE,
-        '#collapsed' => $collapsed,
-    );
-
-    $form['email_message']['subject'] = array(
-      '#type' => 'textfield',
-      '#title' => t('Message Subject'),
-      '#default_value' => $import['options']['subject'],
-      '#description' => t('Customize the subject of the welcome e-mail, which is sent to imported members.') .' '. t('Available variables are:') .' !username, !site, !password, !uri, !uri_brief, !mailto, !date, !login_uri, !edit_uri, !login_url' . $profile_string . '.',
-    ); 
-    
-    $form['email_message']['message'] = array(
-      '#type' => 'textarea',
-      '#title' => t('Message'),
-      '#default_value' => $import['options']['message'],
-      '#description' => t('Customize the body of the welcome e-mail, which is sent to imported members.') .' '. t('Available variables are:') .' !username, !site, !password, !uri, !uri_brief, !mailto, !login_uri, !edit_uri, !login_url' . $profile_string . '.',
-    ); 
-    
-    $form['email_message']['message_format'] = array(
-      '#type' => 'radios',
-      '#title' => t('Email Format'),
-      '#default_value' => empty($import['options']['message_format']) ? 0 : $import['options']['message_format'],
-      '#options' => array(t('Plain Text'), t('HTML')),
-    );
-    
-    $form['email_message']['message_css'] = array(
-      '#type' => 'textarea',
-      '#title' => t('CSS'),
-      '#default_value' => $import['options']['message_css'],
-      '#description' => t('Use if sending HTML formated email.'),
-    );
-    
-    return;
+  $form['email_message'] = array(
+    '#type' => 'fieldset',
+    '#title' => t('Email Message'),
+    '#description' => t('Welcome message to be sent to imported users. Leave blank to use the default !message.<br /><strong>Warning</strong>: if you copy and paste directly from Word some characters may get garbled.', array('!message' => l('message', 'admin/user/settings'))),
+    '#collapsible' => TRUE,
+    '#collapsed' => $collapsed,
+  );
+
+  $form['email_message']['subject'] = array(
+    '#type' => 'textfield',
+    '#title' => t('Message Subject'),
+    '#default_value' => $import['options']['subject'],
+    '#description' => t('Customize the subject of the welcome e-mail, which is sent to imported members.') .' '. t('Available variables are:') .' !username, !site, !password, !uri, !uri_brief, !mailto, !date, !login_uri, !edit_uri, !login_url'. $profile_string .'.',
+  );
+
+  $form['email_message']['message'] = array(
+    '#type' => 'textarea',
+    '#title' => t('Message'),
+    '#default_value' => $import['options']['message'],
+    '#description' => t('Customize the body of the welcome e-mail, which is sent to imported members.') .' '. t('Available variables are:') .' !username, !site, !password, !uri, !uri_brief, !mailto, !login_uri, !edit_uri, !login_url'. $profile_string .'.',
+  );
+
+  $form['email_message']['message_format'] = array(
+    '#type' => 'radios',
+    '#title' => t('Email Format'),
+    '#default_value' => empty($import['options']['message_format']) ? 0 : $import['options']['message_format'],
+    '#options' => array(t('Plain Text'), t('HTML')),
+  );
+
+  $form['email_message']['message_css'] = array(
+    '#type' => 'textarea',
+    '#title' => t('CSS'),
+    '#default_value' => $import['options']['message_css'],
+    '#description' => t('Use if sending HTML formated email.'),
+  );
+
+  return;
 }
 
 
 function _user_import_validate_email($email = NULL, $duplicates_allowed = FALSE) {
-
   if (!$email) {
     user_import_errors(t('no email'));
   }
-  
   elseif (!valid_email_address($email)) {
     user_import_errors(t('invalid email'));
   }
-
   // Handle duplicate emails.
   elseif (!$duplicates_allowed && _user_import_existing_uid($email)) {
     user_import_errors(t('duplicate email'));
   }
-
+  
   return;
 }
diff -urp user_import_orig/supported/watchdog.inc user_import/supported/watchdog.inc
--- user_import_orig/supported/watchdog.inc	2008-05-15 15:16:32.000000000 +0200
+++ user_import/supported/watchdog.inc	2008-06-15 14:32:31.000000000 +0200
@@ -1,11 +1,17 @@
 <?php
+// $Id: watchdog.inc,v 1.17.2.5 2008/05/15 13:16:31 MegaGrunt Exp $
+
+/**
+ * @file
+ * Import watchdog properties.
+ */
 
 /**
  * Implementation of hook_user_import_after_save().
  */
 function watchdog_user_import_after_save($settings, $account, $password, $fields) {
 
-  watchdog('user', t('New user: %name %email.', array('%name' => theme('placeholder', check_plain($account->name)), '%email' => theme('placeholder', '<'. check_plain($account->mail) .'>'))), WATCHDOG_NOTICE, l(t('edit'), 'user/'. $account->uid .'/edit'));
+  watchdog('user', 'New user: %name %email.', array('%name' => theme('placeholder', check_plain($account->name)), '%email' => theme('placeholder', '<'. check_plain($account->mail) .'>')), WATCHDOG_NOTICE, l(t('edit'), 'user/'. $account->uid .'/edit'));
 
   return;
 }
\ No newline at end of file
Only in user_import: user_import.csv
Only in user_import: user_import.csv~
diff -urp user_import_orig/user_import.info user_import/user_import.info
--- user_import_orig/user_import.info	2008-05-16 02:18:43.000000000 +0200
+++ user_import/user_import.info	2008-06-14 15:18:23.000000000 +0200
@@ -15,4 +15,5 @@ project = "user_import"
 version = "5.x-2.x-dev"
 project = "user_import"
 datestamp = "1210897123"
+core = 6.x
 
diff -urp user_import_orig/user_import.install user_import/user_import.install
--- user_import_orig/user_import.install	2008-05-15 15:16:31.000000000 +0200
+++ user_import/user_import.install	2008-06-15 14:30:50.000000000 +0200
@@ -1,8 +1,149 @@
 <?php
-// $Id: user_import.install,v 1.5.2.3 2008/05/15 13:16:31 MegaGrunt Exp $
+// $Id: user_import.install,v 1.17.2.5 2008/05/15 13:16:31 MegaGrunt Exp $
 
 /**
- * Implementation of hook_install()
+ * @file
+ * Import users from a comma separated file (csv).
+ */
+
+/**
+ * Implementation of hook_schema().
+ */
+function user_import_schema() {
+$schema['user_import'] = array(
+    'fields' => array(
+      'import_id' => array(
+        'type' => 'serial',
+        'unsigned' => TRUE,
+        'not null' => TRUE,
+        'disp-width' => '10'
+      ),
+      'name' => array(
+        'type' => 'varchar',
+        'length' => '25',
+        'not null' => TRUE,
+        'default' => ''
+      ),
+      'filename' => array(
+        'type' => 'varchar',
+        'length' => '50',
+        'not null' => TRUE,
+        'default' => ''
+      ),
+      'oldfilename' => array(
+        'type' => 'varchar',
+        'length' => '50',
+        'not null' => TRUE,
+        'default' => ''
+      ),
+      'filepath' => array(
+        'type' => 'text',
+        'size' => 'small',
+        'not null' => TRUE
+      ),
+      'started' => array(
+        'type' => 'int',
+        'not null' => TRUE,
+        'default' => 0,
+        'disp-width' => '11'
+      ),
+      'pointer' => array(
+        'type' => 'int',
+        'not null' => TRUE,
+        'default' => 0,
+        'disp-width' => '10'
+      ),
+      'processed' => array(
+        'type' => 'int',
+        'not null' => TRUE,
+        'default' => 0,
+        'disp-width' => '10'
+      ),
+      'valid' => array(
+        'type' => 'int',
+        'not null' => TRUE,
+        'default' => 0,
+        'disp-width' => '10'
+      ),
+      'first_line_skip' => array(
+        'type' => 'int',
+        'not null' => TRUE,
+        'default' => 0,
+        'disp-width' => '1'
+      ),
+      'contact' => array(
+        'type' => 'int',
+        'not null' => TRUE,
+        'default' => 0,
+        'disp-width' => '1'
+      ),
+      'username_space' => array(
+        'type' => 'int',
+        'not null' => TRUE,
+        'default' => 0,
+        'disp-width' => '1'
+      ),
+      'send_email' => array(
+        'type' => 'int',
+        'not null' => TRUE,
+        'default' => 0,
+        'disp-width' => '1'
+      ),
+      'field_match' => array(
+        'type' => 'text',
+        'size' => 'big',
+        'not null' => TRUE
+      ),
+      'roles' => array(
+        'type' => 'varchar',
+        'length' => '255',
+        'not null' => TRUE,
+        'default' => ''
+      ),
+      'options' => array(
+        'type' => 'text',
+        'size' => 'big',
+        'not null' => TRUE
+      ),
+      'setting' => array(
+        'type' => 'varchar',
+        'length' => '10',
+        'not null' => TRUE,
+        'default' => ''
+      )
+    ),
+    'primary key' => array('import_id'),
+  );
+
+  $schema['user_import_errors'] = array(
+    'fields' => array(
+      'import_id' => array(
+        'type' => 'int',
+        'not null' => TRUE,
+        'default' => 0,
+        'disp-width' => '10'
+      ),
+      'data' => array(
+        'type' => 'text',
+        'size' => 'big',
+        'not null' => TRUE
+      ),
+      'errors' => array(
+        'type' => 'varchar',
+        'length' => '25',
+        'not null' => TRUE,
+        'default' => ''
+      )
+    ),
+    'indexes' => array(
+      'import_id' => array('import_id')
+    ),
+  );
+  return $schema;
+}
+
+/**
+ * Implementation of hook_install().
  *
  * This will automatically install the database tables for the user import module for both the MySQL and PostgreSQL databases.
  *
@@ -12,57 +153,13 @@
  * and will need to be removed.
  */
 function user_import_install() {
-  switch ($GLOBALS['db_type']) {
-    case 'mysqli':
-    case 'mysql':
-      $query1 = db_query("CREATE TABLE IF NOT EXISTS {user_import} (
-                        import_id int(10) unsigned NOT NULL auto_increment,
-                        name varchar(25) NOT NULL default '',
-                        filename varchar(50) NOT NULL default '',
-                        oldfilename varchar(50) NOT NULL default '',
-                        filepath tinytext NOT NULL,
-                        started int(11) NOT NULL default '0',
-                        pointer int(10) NOT NULL default '0',
-                        processed int(10) NOT NULL default '0',
-                        valid int(10) NOT NULL default '0',
-                        first_line_skip int(1) NOT NULL default '0',
-                        contact int(1) NOT NULL default '0',
-                        username_space int(1) NOT NULL default '0',
-                        send_email int(1) NOT NULL default '0',
-                        field_match longtext NOT NULL,
-                        roles varchar(255) NOT NULL default '',
-                        options longtext NOT NULL,
-                        setting varchar(10) NOT NULL default '',
-                        PRIMARY KEY  (import_id)
-                        ) /*!40100 DEFAULT CHARACTER SET utf8 */;");
-  
-      $query2 = db_query("CREATE TABLE IF NOT EXISTS {user_import_errors} (
-                        import_id int(10) NOT NULL default '0',
-                        data longtext NOT NULL,
-                        errors varchar(25) NOT NULL default '',
-                        KEY import_id (import_id)
-                        ) /*!40100 DEFAULT CHARACTER SET utf8 */;");
-
-      if ($query1 && $query2) {
-        $created = TRUE;
-      }
-      break;      
-  }
-  
-  if ($created) {
-    drupal_set_message(t('User Import module installed successfully.'));
-  }
-  else {
-    drupal_set_message(t('Table installation for the User Import module was unsuccessful. The tables may need to be installed by hand. See user_import.install file for a list of the installation queries.'), 'error');
-  }
-  
-  return;
+  drupal_install_schema('user_import');
 }
 
 function user_import_update_1() {
 
     _system_update_utf8(array('user_import', 'user_import_errors'));
-    
+
   return;
 }
 
@@ -75,7 +172,7 @@ function user_import_update_2() {
 function user_import_update_3() {
   $ret = array();
   $ret[] = update_sql("ALTER TABLE {user_import} CHANGE iid import_id INT(10) UNSIGNED NOT NULL AUTO_INCREMENT");
-  $ret[] = update_sql("ALTER TABLE {user_import} CHANGE first_line first_line_skip INT(10) UNSIGNED NOT NULL default '0'");  
+  $ret[] = update_sql("ALTER TABLE {user_import} CHANGE first_line first_line_skip INT(10) UNSIGNED NOT NULL default '0'");
   $ret[] = update_sql("ALTER TABLE {user_import_errors} CHANGE iid import_id INT(10) UNSIGNED NOT NULL default '0'");
   return $ret;
 }
@@ -87,11 +184,10 @@ function user_import_update_4() {
 }
 
 /**
-* Implementation of hook_uninstall().
-*/
+ * Implementation of hook_uninstall().
+ */
 function user_import_uninstall() {
-  db_query('DROP TABLE {user_import}');
-  db_query('DROP TABLE {user_import_errors}');
+  drupal_uninstall_schema('user_import');
   variable_del('user_import_settings');
   variable_del('user_import_max');
   variable_del('user_import_line_max');
diff -urp user_import_orig/user_import.module user_import/user_import.module
--- user_import_orig/user_import.module	2008-05-15 15:16:31.000000000 +0200
+++ user_import/user_import.module	2008-06-18 15:56:24.000000000 +0200
@@ -7,14 +7,14 @@
  */
 
 /**
- * - - - - - - - -  HOOKS - - - - - - - - 
+ * - - - - - - - -  HOOKS - - - - - - - -
  */
 
 /**
  * Implementation of hook_help().
  */
-function user_import_help($section) {
-  switch ($section) {
+function user_import_help($path, $arg) {
+  switch ($path) {
     case 'admin/user/user_import':
       return t("Import users from a comma separated file (csv). Click 'Import' to start a new import.");
   }
@@ -30,112 +30,127 @@ function user_import_perm() {
 /**
  * Implementation of hook_menu().
  */
-function user_import_menu($may_cache) {
-  
+function user_import_menu() {
+
   global $user;
   $items = array();
-  
-     if ($may_cache) {     
-     
-        $items[] = array(
-            'path' => 'admin/user/user_import', 
-            'title' => t('User Imports'), 
-            'callback' => 'user_import_list',
-            'description' => t('Import users from a comma separated file (csv).'),
-            'access' => user_access('import users'),
-            );
-        $items[] = array(
-            'path' => 'admin/user/user_import/list', 
-            'title' => t('List Imports'), 
-            'access' => user_access('import users'),
-            'weight' => -10,
-            'type' => MENU_DEFAULT_LOCAL_TASK
-            );
-        $items[] = array(
-          'path' => 'admin/user/user_import/add', 
-          'title' => t('Import'),
-          'callback' => 'user_import_preferences',
-          'access' => user_access('import users'),
-          'weight' => -5,
-          'type' => MENU_LOCAL_TASK
-        );
-        $items[] = array(
-          'path' => 'admin/user/user_import/continue', 
-          'title' => t('Continue'),
-          'callback' => 'user_import_continue',
-          'access' => user_access('import users'),
-          'type' => MENU_CALLBACK
-        );
-        $items[] = array(
-          'path' => 'admin/user/user_import/import', 
-          'title' => t('Import'),
-          'callback' => 'user_import_import',
-          'access' => user_access('import users'),
-          'type' => MENU_CALLBACK
-        );
-        $items[] = array(
-          'path' => 'admin/user/user_import/delete', 
-          'title' => t('Delete Import'),
-          'callback' => 'user_import_delete',
-          'access' => user_access('import users'),
-          'type' => MENU_CALLBACK
-        );
-        
-        
-        $items[] = array(
-          'path' => 'admin/user/user_import/configure', 
-          'title' => t('Configure'),
-          'callback' => 'drupal_get_form',
-          'callback arguments' => array('user_import_configure_form'),
-          'access' => user_access('import users'),
-          'type' => MENU_LOCAL_TASK
-        );
-        
-        $items[] = array(
-          'path' => 'user_import', 
-          'title' => t('Import Users'),
-          'callback' => 'drupal_get_form',
-          'callback arguments' => array('user_import_preconfigured'),
-          'access' => user_access('limited user import'),
-        );
-        
-        $items[] = array(
-          'path' => 'user_import/delete', 
-          'title' => t('Remove Info'),
-          'callback' => 'user_import_limited_delete',
-          'type' => MENU_CALLBACK,
-          'access' => user_access('limited user import'),
-        );
-        
-        $items[] = array(
-          'path' => 'user_import/errors', 
-          'title' => t('Import Errors'),
-          'callback' => 'user_import_limited_errors',
-          'type' => MENU_CALLBACK,
-          'access' => user_access('limited user import'),
-        ); 
-    }
+
+  $items['admin/user/user_import'] = array(
+    'title' => 'User Imports',
+    'page callback' => 'user_import_list',
+    'description' => 'Import users from a comma separated file (csv).',
+    'access arguments' => array('import users'),
+  );
+  $items['admin/user/user_import/list'] = array(
+    'title' => 'List Imports',
+    'access arguments' => array('import users'),
+    'weight' => -10,
+    'type' => MENU_DEFAULT_LOCAL_TASK
+  );
+  $items['admin/user/user_import/add'] = array(
+    'title' => 'Import',
+    'page callback' => 'user_import_preferences',
+    'access arguments' => array('import users'),
+    'weight' => -5,
+    'type' => MENU_LOCAL_TASK
+  );
+  $items['admin/user/user_import/continue'] = array(
+    'title' => 'Continue',
+    'page callback' => 'user_import_continue',
+    'access arguments' => array('import users'),
+    'type' => MENU_CALLBACK
+  );
+  $items['admin/user/user_import/import'] = array(
+    'title' => 'Import',
+    'page callback' => 'user_import_import',
+    'access arguments' => array('import users'),
+    'type' => MENU_CALLBACK
+  );
+  $items['admin/user/user_import/delete'] = array(
+    'title' => 'Delete Import',
+    'page callback' => 'user_import_delete',
+    'access arguments' => array('import users'),
+    'type' => MENU_CALLBACK
+  );
+  $items['admin/user/user_import/configure'] = array(
+    'title' => 'Configure',
+    'page callback' => 'drupal_get_form',
+    'page arguments' => array('user_import_configure_form'),
+    'access arguments' => array('import users'),
+    'type' => MENU_LOCAL_TASK
+  );
+  $items['user_import'] = array(
+    'title' => 'Import Users',
+    'page callback' => 'drupal_get_form',
+    'page arguments' => array('user_import_preconfigured'),
+    'access arguments' => array('limited user import'),
+  );
+  $items['user_import/delete'] = array(
+    'title' => 'Remove Info',
+    'page callback' => 'user_import_limited_delete',
+    'type' => MENU_CALLBACK,
+    'access arguments' => array('limited user import'),
+  );
+  $items['user_import/errors'] = array(
+    'title' => 'Import Errors',
+    'page callback' => 'user_import_limited_errors',
+    'type' => MENU_CALLBACK,
+    'access arguments' => array('limited user import'),
+  );
 
   return $items;
 }
 
 function user_import_cron() {
-    
-    $imports = _user_import_settings_select();    
-    if (!$imports) return;
-    
+
+  $imports = _user_import_settings_select();
+  
+  if (is_array($imports)) {
     foreach ($imports as $import) {
-        
-        if ($import['setting'] == 'test' || $import['setting'] == 'import') _user_import_process($import);
+      if ($import['setting'] == 'test' || $import['setting'] == 'import') _user_import_process($import);
     }
-        
-    return;
+  }
+  
+  $file = variable_get('user_import_file', 'user_import.csv');
+  $path = drupal_get_path('module', 'user_import');
+
+  $settings_template = variable_get('user_import_settings', '2');
+  $template = _user_import_settings_select($settings_template);
+  $form_state['values']['filename'] = $file;
+  $form_state['values']['oldfilename'] = $file;
+  $form_state['values']['filepath'] = $path.'/'.$file;
+
+  // create import setting
+  $import = _user_import_settings_save($form_state['values']);
+  $import['first_line_skip'] = $template['first_line_skip'];
+  $import['contact'] = $template['contact'];
+  $import['username_space'] = $template['username_space'];
+  $import['send_email'] = $template['send_email'];
+  $import['field_match'] = $template['field_match'];
+  $import['roles'] = $template['roles'];
+  $import['options'] = $template['options'];
+  $import['update_users'] = 1;
+  $import['activate'] = 1;
+  $import['setting'] = 'import';
+
+  $filepath = file_move($import['filepath'], file_directory_path() .'/'. $import['filename']);
+  if (!empty($template['og_id'])) $import['groups'][$template['og_id']] = $template['og_id'];
+
+  $import = _user_import_settings_save($import);
+
+  $import['save']['update'] = NULL;
+  $import['import_template_id'] = NULL;
+  $import['save']['name'] = NULL;
+
+  _user_import_process($import);
+
+  return;
 }
 
-// - - - - - - - -  FORMS - - - - - - - - 
+// - - - - - - - -  FORMS - - - - - - - -
+
+function user_import_configure_form() {
 
-function user_import_configure_form() { 
-        
     $form['performance'] = array(
         '#type' => 'fieldset',
         '#title' => t('Performance'),
@@ -151,7 +166,7 @@ function user_import_configure_form() { 
         '#maxlength' => 10,
         '#description' => t('Maximum number of users to import each time the file is processed, useful for controling the rate at which emails are sent out.'),
     );
-    
+
     $form['performance']['user_import_line_max'] = array(
         '#type' => 'textfield',
         '#title' => t('Maximum length of line'),
@@ -160,45 +175,42 @@ function user_import_configure_form() { 
         '#maxlength' => 10,
         '#description' => t('The default is set at 1,000 characters, if a line in your csv is longer than this you should set a higher maximum here. Setting higher maximums will slow down imports.'),
     );
-    
-    
+
+
     $saved_templates = _user_import_settings_select(NULL, 'GET TEMPLATES');
-    
+
     if (!empty($saved_templates)) {
- 
+
         $form['settings_templates'] = array(
             '#type' => 'fieldset',
             '#title' => t('Settings Templates'),
             '#collapsible' => TRUE,
             '#collapsed' => TRUE,
         );
-        
+
         $templates_list = array('-- none --');
-        
+
         foreach ($saved_templates AS $template) {
             $templates_list[$template['import_id']] = $template['name'];
             $templates_delete[$template['import_id']] = $template['name'];
         }
-        
-        $form['settings_templates']['user_import_settings'] = array( 
+        $form['settings_templates']['user_import_settings'] = array(
             '#type' => 'select',
             '#title' => t('Default Settings'),
             '#description' => t('Select if you want to use a previously saved set of settings as default for all imports.'),
             '#default_value' => variable_get('user_import_settings', 0),
             '#options' => $templates_list,
         );
-
-        
         $form['settings_templates']['templates'] = array(
             '#type' => 'checkboxes',
             '#title' => t('Delete Templates'),
             '#options' => $templates_delete,
         );
-    
+
     }
-    
+
     $check_usernames = variable_get('user_export_checked_usernames', 0);
-    
+
     $form['check_names'] = array(
         '#type' => 'fieldset',
         '#title' => t('Check Existing Usernames'),
